// This file is part of the SV-Benchmarks collection of verification tasks:
// https://gitlab.com/sosy-lab/benchmarking/sv-benchmarks
//
// SPDX-FileCopyrightText: 2020 Aman Goel
// SPDX-FileCopyrightText: 2022 The SV-Benchmarks Community
//
// SPDX-License-Identifier: GPL-3.0-or-later

// This C program is converted from Btor2 by Btor2C version sha1:a0fa249
//   with arguments: { architecture=64, lazy_modulo=false, use_memmove=false, unroll_inner_loops=false, shortest_type=true, diff_type=true, decimal_constant=true, zero_init=false, sra_extend_sign=true }
// Comments from the original Btor2 file:
// ; source: https://github.com/aman-goel/avr/tree/92362931700b66684418a991d018c9fbdbebc06f/tests
// ; BTOR description generated by Yosys 0.9+431 (git sha1 4a3b5437, clang 4.0.1-6 -fPIC -Os) for module main.
extern unsigned char __VERIFIER_nondet_uchar();
extern unsigned short __VERIFIER_nondet_ushort();
extern unsigned int __VERIFIER_nondet_uint();
extern unsigned long __VERIFIER_nondet_ulong();
extern void abort(void);
extern void __assert_fail(const char *, const char *, unsigned int, const char *);
void reach_error() { __assert_fail("0", "h_Spinner.c", 0, "reach_error"); }
void __VERIFIER_assert(int cond) { if (!(cond)) { ERROR: { reach_error(); abort(); } } }
void assume_abort_if_not(int cond) { if (!cond) { abort(); } }
int main() {
  // Defining sorts ...
  typedef unsigned char SORT_1;  // BV with 5 bits
  const SORT_1 mask_SORT_1 = (SORT_1)-1 >> (sizeof(SORT_1) * 8 - 5);
  const SORT_1 msb_SORT_1 = (SORT_1)1 << (5 - 1);
  typedef unsigned char SORT_3;  // BV with 1 bits
  const SORT_3 mask_SORT_3 = (SORT_3)-1 >> (sizeof(SORT_3) * 8 - 1);
  const SORT_3 msb_SORT_3 = (SORT_3)1 << (1 - 1);
  typedef unsigned int SORT_5;  // BV with 32 bits
  const SORT_5 mask_SORT_5 = (SORT_5)-1 >> (sizeof(SORT_5) * 8 - 32);
  const SORT_5 msb_SORT_5 = (SORT_5)1 << (32 - 1);
  typedef unsigned int SORT_47;  // BV with 31 bits
  const SORT_47 mask_SORT_47 = (SORT_47)-1 >> (sizeof(SORT_47) * 8 - 31);
  const SORT_47 msb_SORT_47 = (SORT_47)1 << (31 - 1);
  typedef unsigned int SORT_57;  // BV with 30 bits
  const SORT_57 mask_SORT_57 = (SORT_57)-1 >> (sizeof(SORT_57) * 8 - 30);
  const SORT_57 msb_SORT_57 = (SORT_57)1 << (30 - 1);
  typedef unsigned int SORT_59;  // BV with 29 bits
  const SORT_59 mask_SORT_59 = (SORT_59)-1 >> (sizeof(SORT_59) * 8 - 29);
  const SORT_59 msb_SORT_59 = (SORT_59)1 << (29 - 1);
  typedef unsigned char SORT_65;  // BV with 2 bits
  const SORT_65 mask_SORT_65 = (SORT_65)-1 >> (sizeof(SORT_65) * 8 - 2);
  const SORT_65 msb_SORT_65 = (SORT_65)1 << (2 - 1);
  typedef unsigned int SORT_71;  // BV with 28 bits
  const SORT_71 mask_SORT_71 = (SORT_71)-1 >> (sizeof(SORT_71) * 8 - 28);
  const SORT_71 msb_SORT_71 = (SORT_71)1 << (28 - 1);
  typedef unsigned int SORT_73;  // BV with 26 bits
  const SORT_73 mask_SORT_73 = (SORT_73)-1 >> (sizeof(SORT_73) * 8 - 26);
  const SORT_73 msb_SORT_73 = (SORT_73)1 << (26 - 1);
  typedef unsigned char SORT_79;  // BV with 4 bits
  const SORT_79 mask_SORT_79 = (SORT_79)-1 >> (sizeof(SORT_79) * 8 - 4);
  const SORT_79 msb_SORT_79 = (SORT_79)1 << (4 - 1);
  typedef unsigned int SORT_85;  // BV with 24 bits
  const SORT_85 mask_SORT_85 = (SORT_85)-1 >> (sizeof(SORT_85) * 8 - 24);
  const SORT_85 msb_SORT_85 = (SORT_85)1 << (24 - 1);
  typedef unsigned int SORT_87;  // BV with 20 bits
  const SORT_87 mask_SORT_87 = (SORT_87)-1 >> (sizeof(SORT_87) * 8 - 20);
  const SORT_87 msb_SORT_87 = (SORT_87)1 << (20 - 1);
  typedef unsigned char SORT_93;  // BV with 8 bits
  const SORT_93 mask_SORT_93 = (SORT_93)-1 >> (sizeof(SORT_93) * 8 - 8);
  const SORT_93 msb_SORT_93 = (SORT_93)1 << (8 - 1);
  typedef unsigned short SORT_99;  // BV with 16 bits
  const SORT_99 mask_SORT_99 = (SORT_99)-1 >> (sizeof(SORT_99) * 8 - 16);
  const SORT_99 msb_SORT_99 = (SORT_99)1 << (16 - 1);
  // Initializing constants ...
  const SORT_5 var_8 = 0;
  const SORT_3 var_19 = 0;
  const SORT_3 var_40 = 1;
  // Collecting input declarations ...
  SORT_1 input_2;
  SORT_3 input_4;
  SORT_5 input_6;
  SORT_3 input_7;
  // Collecting state declarations ...
  SORT_5 state_9 = __VERIFIER_nondet_uint() & mask_SORT_5;
  SORT_5 state_13 = __VERIFIER_nondet_uint() & mask_SORT_5;
  SORT_3 state_20 = __VERIFIER_nondet_uchar() & mask_SORT_3;
  // Initializing states ...
  SORT_5 init_10_arg_1 = var_8;
  state_9 = init_10_arg_1;
  SORT_5 init_14_arg_1 = var_8;
  state_13 = init_14_arg_1;
  SORT_3 init_21_arg_1 = var_19;
  state_20 = init_21_arg_1;
  for (;;) {
    // Getting external input values ...
    input_2 = __VERIFIER_nondet_uchar();
    input_2 = input_2 & mask_SORT_1;
    input_4 = __VERIFIER_nondet_uchar();
    input_4 = input_4 & mask_SORT_3;
    input_6 = __VERIFIER_nondet_uint();
    input_6 = input_6 & mask_SORT_5;
    input_7 = __VERIFIER_nondet_uchar();
    input_7 = input_7 & mask_SORT_3;
    // Assuming invariants ...
    // Asserting properties ...
    SORT_5 var_11_arg_0 = state_9;
    SORT_5 var_11_arg_1 = var_8;
    SORT_3 var_11 = var_11_arg_0 == var_11_arg_1;
    SORT_3 var_12_arg_0 = var_11;
    SORT_3 var_12 = ~var_12_arg_0;
    var_12 = var_12 & mask_SORT_3;
    SORT_5 var_15_arg_0 = state_13;
    SORT_5 var_15_arg_1 = var_8;
    SORT_3 var_15 = var_15_arg_0 == var_15_arg_1;
    SORT_3 var_16_arg_0 = var_15;
    SORT_3 var_16 = ~var_16_arg_0;
    var_16 = var_16 & mask_SORT_3;
    SORT_3 var_17_arg_0 = var_12;
    SORT_3 var_17_arg_1 = var_16;
    SORT_3 var_17 = var_17_arg_0 & var_17_arg_1;
    var_17 = var_17 & mask_SORT_3;
    SORT_3 var_18_arg_0 = var_17;
    SORT_3 var_18 = ~var_18_arg_0;
    var_18 = var_18 & mask_SORT_3;
    SORT_3 var_22_arg_0 = state_20;
    SORT_5 var_22 = var_22_arg_0;
    SORT_5 var_23_arg_0 = var_22;
    SORT_5 var_23_arg_1 = var_8;
    SORT_3 var_23 = var_23_arg_0 == var_23_arg_1;
    SORT_5 var_24_arg_0 = state_9;
    SORT_5 var_24_arg_1 = var_8;
    SORT_3 var_24 = var_24_arg_0 == var_24_arg_1;
    SORT_3 var_25_arg_0 = var_24;
    SORT_3 var_25 = ~var_25_arg_0;
    var_25 = var_25 & mask_SORT_3;
    SORT_3 var_26_arg_0 = var_23;
    SORT_3 var_26_arg_1 = var_25;
    SORT_3 var_26 = var_26_arg_0 | var_26_arg_1;
    var_26 = var_26 & mask_SORT_3;
    SORT_3 var_27_arg_0 = var_18;
    SORT_3 var_27_arg_1 = var_26;
    SORT_3 var_27 = var_27_arg_0 | var_27_arg_1;
    var_27 = var_27 & mask_SORT_3;
    SORT_5 var_28_arg_0 = state_9;
    SORT_5 var_28_arg_1 = var_8;
    SORT_3 var_28 = var_28_arg_0 == var_28_arg_1;
    SORT_5 var_29_arg_0 = state_13;
    SORT_5 var_29_arg_1 = var_8;
    SORT_3 var_29 = var_29_arg_0 == var_29_arg_1;
    SORT_3 var_30_arg_0 = var_28;
    SORT_3 var_30_arg_1 = var_29;
    SORT_3 var_30 = var_30_arg_0 & var_30_arg_1;
    var_30 = var_30 & mask_SORT_3;
    SORT_3 var_31_arg_0 = var_30;
    SORT_3 var_31 = ~var_31_arg_0;
    var_31 = var_31 & mask_SORT_3;
    SORT_3 var_32_arg_0 = state_20;
    SORT_5 var_32 = var_32_arg_0;
    SORT_5 var_33_arg_0 = var_32;
    SORT_5 var_33_arg_1 = var_8;
    SORT_3 var_33 = var_33_arg_0 == var_33_arg_1;
    SORT_5 var_34_arg_0 = state_9;
    SORT_5 var_34_arg_1 = var_8;
    SORT_3 var_34 = var_34_arg_0 == var_34_arg_1;
    SORT_3 var_35_arg_0 = var_33;
    SORT_3 var_35_arg_1 = var_34;
    SORT_3 var_35 = var_35_arg_0 | var_35_arg_1;
    var_35 = var_35 & mask_SORT_3;
    SORT_3 var_36_arg_0 = var_31;
    SORT_3 var_36_arg_1 = var_35;
    SORT_3 var_36 = var_36_arg_0 | var_36_arg_1;
    var_36 = var_36 & mask_SORT_3;
    SORT_3 var_37_arg_0 = var_27;
    SORT_3 var_37_arg_1 = var_36;
    SORT_3 var_37 = var_37_arg_0 & var_37_arg_1;
    var_37 = var_37 & mask_SORT_3;
    SORT_3 var_41_arg_0 = var_37;
    SORT_3 var_41 = ~var_41_arg_0;
    var_41 = var_41 & mask_SORT_3;
    SORT_3 var_42_arg_0 = var_40;
    SORT_3 var_42_arg_1 = var_41;
    SORT_3 var_42 = var_42_arg_0 & var_42_arg_1;
    var_42 = var_42 & mask_SORT_3;
    SORT_3 bad_43_arg_0 = var_42;
    __VERIFIER_assert(!(bad_43_arg_0));
    // Computing next states ...
    SORT_3 var_108_arg_0 = state_20;
    SORT_5 var_108_arg_1 = state_13;
    SORT_5 var_108_arg_2 = input_6;
    SORT_5 var_108 = var_108_arg_0 ? var_108_arg_1 : var_108_arg_2;
    SORT_5 next_109_arg_1 = var_108;
    SORT_1 var_103_arg_0 = input_2;
    SORT_3 var_103 = var_103_arg_0 >> 4;
    var_103 = var_103 & mask_SORT_3;
    SORT_1 var_90_arg_0 = input_2;
    SORT_3 var_90 = var_90_arg_0 >> 3;
    var_90 = var_90 & mask_SORT_3;
    SORT_1 var_76_arg_0 = input_2;
    SORT_3 var_76 = var_76_arg_0 >> 2;
    var_76 = var_76 & mask_SORT_3;
    SORT_1 var_62_arg_0 = input_2;
    SORT_3 var_62 = var_62_arg_0 >> 1;
    var_62 = var_62 & mask_SORT_3;
    SORT_1 var_50_arg_0 = input_2;
    SORT_3 var_50 = var_50_arg_0 >> 0;
    var_50 = var_50 & mask_SORT_3;
    SORT_5 var_54_arg_0 = state_9;
    SORT_3 var_54 = var_54_arg_0 >> 0;
    var_54 = var_54 & mask_SORT_3;
    SORT_5 var_53_arg_0 = state_9;
    SORT_3 var_53 = var_53_arg_0 >> 31;
    var_53 = var_53 & mask_SORT_3;
    SORT_3 var_55_arg_0 = var_50;
    SORT_3 var_55_arg_1 = var_54;
    SORT_3 var_55_arg_2 = var_53;
    SORT_3 var_55 = var_55_arg_0 ? var_55_arg_1 : var_55_arg_2;
    SORT_5 var_49_arg_0 = state_9;
    SORT_47 var_49 = var_49_arg_0 >> 1;
    var_49 = var_49 & mask_SORT_47;
    SORT_5 var_48_arg_0 = state_9;
    SORT_47 var_48 = var_48_arg_0 >> 0;
    var_48 = var_48 & mask_SORT_47;
    SORT_3 var_51_arg_0 = var_50;
    SORT_47 var_51_arg_1 = var_49;
    SORT_47 var_51_arg_2 = var_48;
    SORT_47 var_51 = var_51_arg_0 ? var_51_arg_1 : var_51_arg_2;
    SORT_47 var_60_arg_0 = var_51;
    SORT_59 var_60 = var_60_arg_0 >> 2;
    var_60 = var_60 & mask_SORT_59;
    SORT_3 var_61_arg_0 = var_55;
    SORT_59 var_61_arg_1 = var_60;
    SORT_57 var_61 = ((SORT_57)var_61_arg_0 << 29) | var_61_arg_1;
    SORT_47 var_58_arg_0 = var_51;
    SORT_57 var_58 = var_58_arg_0 >> 0;
    var_58 = var_58 & mask_SORT_57;
    SORT_3 var_63_arg_0 = var_62;
    SORT_57 var_63_arg_1 = var_61;
    SORT_57 var_63_arg_2 = var_58;
    SORT_57 var_63 = var_63_arg_0 ? var_63_arg_1 : var_63_arg_2;
    SORT_57 var_82_arg_0 = var_63;
    SORT_79 var_82 = var_82_arg_0 >> 0;
    var_82 = var_82 & mask_SORT_79;
    SORT_47 var_68_arg_0 = var_51;
    SORT_65 var_68 = var_68_arg_0 >> 0;
    var_68 = var_68 & mask_SORT_65;
    SORT_47 var_66_arg_0 = var_51;
    SORT_3 var_66 = var_66_arg_0 >> 30;
    var_66 = var_66 & mask_SORT_3;
    SORT_3 var_67_arg_0 = var_55;
    SORT_3 var_67_arg_1 = var_66;
    SORT_65 var_67 = ((SORT_65)var_67_arg_0 << 1) | var_67_arg_1;
    SORT_3 var_69_arg_0 = var_62;
    SORT_65 var_69_arg_1 = var_68;
    SORT_65 var_69_arg_2 = var_67;
    SORT_65 var_69 = var_69_arg_0 ? var_69_arg_1 : var_69_arg_2;
    SORT_57 var_80_arg_0 = var_63;
    SORT_65 var_80 = var_80_arg_0 >> 28;
    var_80 = var_80 & mask_SORT_65;
    SORT_65 var_81_arg_0 = var_69;
    SORT_65 var_81_arg_1 = var_80;
    SORT_79 var_81 = ((SORT_79)var_81_arg_0 << 2) | var_81_arg_1;
    SORT_3 var_83_arg_0 = var_76;
    SORT_79 var_83_arg_1 = var_82;
    SORT_79 var_83_arg_2 = var_81;
    SORT_79 var_83 = var_83_arg_0 ? var_83_arg_1 : var_83_arg_2;
    SORT_57 var_74_arg_0 = var_63;
    SORT_73 var_74 = var_74_arg_0 >> 4;
    var_74 = var_74 & mask_SORT_73;
    SORT_65 var_75_arg_0 = var_69;
    SORT_73 var_75_arg_1 = var_74;
    SORT_71 var_75 = ((SORT_71)var_75_arg_0 << 26) | var_75_arg_1;
    SORT_57 var_72_arg_0 = var_63;
    SORT_71 var_72 = var_72_arg_0 >> 0;
    var_72 = var_72 & mask_SORT_71;
    SORT_3 var_77_arg_0 = var_76;
    SORT_71 var_77_arg_1 = var_75;
    SORT_71 var_77_arg_2 = var_72;
    SORT_71 var_77 = var_77_arg_0 ? var_77_arg_1 : var_77_arg_2;
    SORT_71 var_88_arg_0 = var_77;
    SORT_87 var_88 = var_88_arg_0 >> 8;
    var_88 = var_88 & mask_SORT_87;
    SORT_79 var_89_arg_0 = var_83;
    SORT_87 var_89_arg_1 = var_88;
    SORT_85 var_89 = ((SORT_85)var_89_arg_0 << 20) | var_89_arg_1;
    SORT_71 var_86_arg_0 = var_77;
    SORT_85 var_86 = var_86_arg_0 >> 0;
    var_86 = var_86 & mask_SORT_85;
    SORT_3 var_91_arg_0 = var_90;
    SORT_85 var_91_arg_1 = var_89;
    SORT_85 var_91_arg_2 = var_86;
    SORT_85 var_91 = var_91_arg_0 ? var_91_arg_1 : var_91_arg_2;
    SORT_85 var_100_arg_0 = var_91;
    SORT_99 var_100 = var_100_arg_0 >> 0;
    var_100 = var_100 & mask_SORT_99;
    SORT_71 var_96_arg_0 = var_77;
    SORT_93 var_96 = var_96_arg_0 >> 0;
    var_96 = var_96 & mask_SORT_93;
    SORT_71 var_94_arg_0 = var_77;
    SORT_79 var_94 = var_94_arg_0 >> 24;
    var_94 = var_94 & mask_SORT_79;
    SORT_79 var_95_arg_0 = var_83;
    SORT_79 var_95_arg_1 = var_94;
    SORT_93 var_95 = ((SORT_93)var_95_arg_0 << 4) | var_95_arg_1;
    SORT_3 var_97_arg_0 = var_90;
    SORT_93 var_97_arg_1 = var_96;
    SORT_93 var_97_arg_2 = var_95;
    SORT_93 var_97 = var_97_arg_0 ? var_97_arg_1 : var_97_arg_2;
    SORT_85 var_101_arg_0 = var_91;
    SORT_93 var_101 = var_101_arg_0 >> 16;
    var_101 = var_101 & mask_SORT_93;
    SORT_93 var_102_arg_0 = var_97;
    SORT_93 var_102_arg_1 = var_101;
    SORT_99 var_102 = ((SORT_99)var_102_arg_0 << 8) | var_102_arg_1;
    SORT_3 var_106_arg_0 = var_103;
    SORT_99 var_106_arg_1 = var_100;
    SORT_99 var_106_arg_2 = var_102;
    SORT_99 var_106 = var_106_arg_0 ? var_106_arg_1 : var_106_arg_2;
    SORT_3 var_104_arg_0 = var_103;
    SORT_99 var_104_arg_1 = var_102;
    SORT_99 var_104_arg_2 = var_100;
    SORT_99 var_104 = var_104_arg_0 ? var_104_arg_1 : var_104_arg_2;
    SORT_99 var_110_arg_0 = var_106;
    SORT_99 var_110_arg_1 = var_104;
    SORT_5 var_110 = ((SORT_5)var_110_arg_0 << 16) | var_110_arg_1;
    SORT_5 next_111_arg_1 = var_110;
    SORT_3 next_112_arg_1 = input_7;
    // Assigning next states ...
    state_9 = next_109_arg_1;
    state_13 = next_111_arg_1;
    state_20 = next_112_arg_1;
  }
  return 0;
}
